
import java.io.FileInputStream;
import java.io.IOException;

class Bitmap3D {
	// public int NX = 64;
	// public int NY = 57;
	// public int NZ = 64;
	// String filename = "johnDoe64x57x64.dat";
	public int NX = 128;
	public int NY = 114;
	public int NZ = 128;
	String filename = "johnDoe128x114x128.dat";

	public float threshold = 0.12f;

	float [] V = null;

	public void readFile() {
		try {
			FileInputStream fis = new FileInputStream(filename);
			byte [] byteArray = new byte[ NX*NY*NZ*2 ];
			fis.read(byteArray);
			fis.close();
			V = new float[ NX*NY*NZ ];
			for ( int x = 0; x < NX; ++x ) {
				for ( int y = 0; y < NY; ++y ) {
					for ( int z = 0; z < NZ; ++z ) {
						setVoxel(
							x,y,z,
							(
								((int)byteArray[(x*NY*NZ + y*NZ + z)*2] & 0xFF)
								| (((int)byteArray[(x*NY*NZ + y*NZ + z)*2+1] & 0xFF)<<8)
							) / 65535.0f
						);
					}
				}
			}
		} catch (IOException e) {
			System.out.println("Error in Bitmap3D.readFile() !");
			System.exit(1);
		}
	}

	public void setVoxel(int x,int y,int z, float value ) {
		V[ x*NY*NZ + y*NZ + z ] = value;
	}

	// returns a value between 0.0f and 1.0f
	public float getVoxel(int x,int y,int z) {
		return V[ x*NY*NZ + y*NZ + z ];
	}

	public AlignedBox3D getBoundingBox() {
		return new AlignedBox3D( new Point3D(0,0,0), new Point3D(NX,NY,NZ) );
	}
}


